diff --git a/changelog b/changelog
index f76cb32..7267459 100644
--- a/changelog
+++ b/changelog
@@ -1,3 +1,5 @@
+20081227 tpd src/axiom-website/patches.html 20081227.01.tpd.patch
+20081227 tpd src/algebra/Makefile complete build order change
 20081226 tpd src/axiom-website/patches.html 20081226.02.tpd.patch
 20081226 tpd src/algebra/Makefile rearrange build order
 20081226 tpd src/axiom-website/patches.html 20081226.01.tpd.patch
diff --git a/src/algebra/Makefile.pamphlet b/src/algebra/Makefile.pamphlet
index 6e070ed..c3c7d03 100644
--- a/src/algebra/Makefile.pamphlet
+++ b/src/algebra/Makefile.pamphlet
@@ -233,6 +233,7 @@ OASGP PDRING
 <<layer2>>=
 
 LAYER2=\
+  ${OUT}/ASP29.o    \
   ${OUT}/ATRIG.o    ${OUT}/ATRIG-.o   ${OUT}/BMODULE.o  ${OUT}/CACHSET.o  \
   ${OUT}/CHARNZ.o   ${OUT}/CHARZ.o    ${OUT}/DVARCAT.o  ${OUT}/DVARCAT-.o \
   ${OUT}/ELEMFUN.o  ${OUT}/ELEMFUN-.o ${OUT}/ESTOOLS2.o ${OUT}/EVALAB.o   \
@@ -376,14 +377,15 @@ LAYER8=\
 
 @
 \subsection{Layer9}
-Depends on: BTAGG FLALG MATCAT SRAGG VECTCAT\\
+Depends on: BTAGG FLALG LODOCAT MATCAT SRAGG VECTCAT\\
 Used by next layer: IVECTOR PTCAT STRICAT 
 <<layer9>>=
 
 LAYER9=\
-  ${OUT}/BITS.o    ${OUT}/DIRPROD2.o ${OUT}/IMATRIX.o  ${OUT}/IVECTOR.o \
-  ${OUT}/LPOLY.o   ${OUT}/LSMP.o     ${OUT}/LSMP1.o    ${OUT}/MATCAT2.o \
-  ${OUT}/PTCAT.o   ${OUT}/STRICAT.o  ${OUT}/TRIMAT.o  \
+  ${OUT}/BITS.o    ${OUT}/DIRPROD2.o ${OUT}/IMATRIX.o  ${OUT}/INTRVL.o  \
+  ${OUT}/IVECTOR.o ${OUT}/LODO1.o    ${OUT}/LODO2.o    ${OUT}/LPOLY.o   \
+  ${OUT}/LSMP.o    ${OUT}/LSMP1.o    ${OUT}/MATCAT2.o ${OUT}/PTCAT.o   \
+  ${OUT}/STRICAT.o ${OUT}/TRIMAT.o  \
   layer9done
 
 @
@@ -393,16 +395,16 @@ Used by next layer: DIRPCAT FAXF PFECAT STRING
 <<layer10>>=
 
 LAYER10=\
-  ${OUT}/ASSOCEQ.o  ${OUT}/CARTEN.o   ${OUT}/CLIF.o     ${OUT}/CLIP.o     \
-  ${OUT}/COORDSYS.o ${OUT}/DBASE.o    ${OUT}/DHMATRIX.o ${OUT}/DIOSP.o    \
-  ${OUT}/DIRPCAT.o  ${OUT}/DIRPCAT-.o ${OUT}/D02BBFA.o  ${OUT}/D02BHFA.o  \
-  ${OUT}/D02CJFA.o  ${OUT}/FAXF.o     ${OUT}/FAXF-.o    ${OUT}/FFPOLY2.o  \
-  ${OUT}/FNLA.o     ${OUT}/GRAY.o     ${OUT}/HB.o       ${OUT}/IRSN.o     \
-  ${OUT}/MCALCFN.o  ${OUT}/MHROWRED.o ${OUT}/NUMODE.o   ${OUT}/NUMQUAD.o  \
-  ${OUT}/ODESYS.o   ${OUT}/ODETOOLS.o ${OUT}/ORDFUNS.o  ${OUT}/PERMAN.o   \
-  ${OUT}/PFECAT.o   ${OUT}/PFECAT-.o  ${OUT}/POINT.o    ${OUT}/PSEUDLIN.o \
-  ${OUT}/PTPACK.o   ${OUT}/REP2.o     ${OUT}/SETMN.o    ${OUT}/SEX.o      \
-  ${OUT}/STRING.o   ${OUT}/SYMFUNC.o  ${OUT}/VECTOR2.o \
+  ${OUT}/ASSOCEQ.o  ${OUT}/CARTEN.o   ${OUT}/CLIF.o     ${OUT}/CLIP.o    \
+  ${OUT}/COORDSYS.o ${OUT}/DBASE.o    ${OUT}/DHMATRIX.o ${OUT}/DIOSP.o   \
+  ${OUT}/DIRPCAT.o  ${OUT}/DIRPCAT-.o ${OUT}/D02BBFA.o  ${OUT}/D02BHFA.o \
+  ${OUT}/D02CJFA.o  ${OUT}/FAXF.o     ${OUT}/FAXF-.o    ${OUT}/FFPOLY2.o \
+  ${OUT}/FNLA.o     ${OUT}/GRAY.o     ${OUT}/HB.o       ${OUT}/INBFF.o   \
+  ${OUT}/IRSN.o     ${OUT}/MCALCFN.o  ${OUT}/MHROWRED.o ${OUT}/NUMODE.o  \
+  ${OUT}/NUMQUAD.o  ${OUT}/ODESYS.o   ${OUT}/ODETOOLS.o ${OUT}/ORDFUNS.o \
+  ${OUT}/PERMAN.o   ${OUT}/PFECAT.o   ${OUT}/PFECAT-.o  ${OUT}/POINT.o   \
+  ${OUT}/PSEUDLIN.o ${OUT}/PTPACK.o   ${OUT}/REP2.o     ${OUT}/SETMN.o   \
+  ${OUT}/SEX.o      ${OUT}/STRING.o   ${OUT}/SYMFUNC.o  ${OUT}/VECTOR2.o \
   layer10done
 
 @
@@ -458,16 +460,17 @@ LAYER11=\
   ${OUT}/RATFACT.o  ${OUT}/RCFIELD.o  ${OUT}/RCFIELD-.o ${OUT}/RDETR.o    \
   ${OUT}/RDETRS.o   ${OUT}/REAL0.o    ${OUT}/REAL0Q.o   ${OUT}/REALSOLV.o \
   ${OUT}/RESRING.o  ${OUT}/RETSOL.o   ${OUT}/RF.o       ${OUT}/RFFACTOR.o \
-  ${OUT}/RMATCAT.o  ${OUT}/RMATCAT-.o ${OUT}/RRCC.o     ${OUT}/RRCC-.o    \
-  ${OUT}/SCPKG.o    ${OUT}/SHDP.o     ${OUT}/SHP.o      ${OUT}/SIGNRF.o   \
-  ${OUT}/SMITH.o    ${OUT}/SMP.o      ${OUT}/SMTS.o     ${OUT}/SOLVEFOR.o \
-  ${OUT}/SPLTREE.o  ${OUT}/STINPROD.o ${OUT}/STTFNC.o   ${OUT}/SUBRESP.o  \
-  ${OUT}/SUMRF.o    ${OUT}/SUP.o      ${OUT}/SUPEXPR.o  ${OUT}/SUPFRACF.o \
-  ${OUT}/TANEXP.o   ${OUT}/TEMUTL.o   ${OUT}/TEX.o      ${OUT}/TEXTFILE.o \
-  ${OUT}/TREE.o     ${OUT}/TWOFACT.o  ${OUT}/UNIFACT.o  ${OUT}/UP.o       \
-  ${OUT}/UPCDEN.o   ${OUT}/UPDECOMP.o ${OUT}/UPDIVP.o   ${OUT}/UPMP.o     \
-  ${OUT}/UPOLYC2.o  ${OUT}/UPXSCAT.o  ${OUT}/UPSQFREE.o ${OUT}/VIEWDEF.o  \
-  ${OUT}/VIEW2D.o   ${OUT}/VOID.o     ${OUT}/WEIER.o    ${OUT}/WP.o \
+  ${OUT}/RINTERP.o  ${OUT}/RMATCAT.o  ${OUT}/RMATCAT-.o ${OUT}/RRCC.o     \
+  ${OUT}/RRCC-.o    ${OUT}/SCPKG.o    ${OUT}/SHDP.o     ${OUT}/SHP.o      \
+  ${OUT}/SIGNRF.o   ${OUT}/SMITH.o    ${OUT}/SMP.o      ${OUT}/SMTS.o     \
+  ${OUT}/SOLVEFOR.o ${OUT}/SPLTREE.o  ${OUT}/STINPROD.o ${OUT}/STTF.o     \
+  ${OUT}/STTFNC.o   ${OUT}/SUBRESP.o  ${OUT}/SUBSPACE.o ${OUT}/SUMRF.o    \
+  ${OUT}/SUP.o      ${OUT}/SUPEXPR.o  ${OUT}/SUPFRACF.o ${OUT}/TANEXP.o   \
+  ${OUT}/TEMUTL.o   ${OUT}/TEX.o      ${OUT}/TEXTFILE.o ${OUT}/TREE.o     \
+  ${OUT}/TWOFACT.o  ${OUT}/UNIFACT.o  ${OUT}/UP.o       ${OUT}/UPCDEN.o   \
+  ${OUT}/UPDECOMP.o ${OUT}/UPDIVP.o   ${OUT}/UPMP.o     ${OUT}/UPOLYC2.o  \
+  ${OUT}/UPXSCAT.o  ${OUT}/UPSQFREE.o ${OUT}/VIEWDEF.o  ${OUT}/VIEW2D.o   \
+  ${OUT}/VOID.o     ${OUT}/WEIER.o    ${OUT}/WP.o \
   layer11done
 
 @
@@ -505,12 +508,12 @@ Used by next layer: TBAGG
 <<layer14>>=
 
 LAYER14=\
-  ${OUT}/CCLASS.o   ${OUT}/FSAGG2.o  ${OUT}/GALFACT.o ${OUT}/IALGFACT.o \
-  ${OUT}/IBACHIN.o  ${OUT}/MMLFORM.o ${OUT}/NORMMA.o  ${OUT}/ODERED.o   \
-  ${OUT}/OMSAGG.o   ${OUT}/PERM.o    ${OUT}/PERMGRP.o ${OUT}/PRIMES.o   \
-  ${OUT}/PWFFINTB.o ${OUT}/RDIST.o   ${OUT}/SAE.o     ${OUT}/SAEFACT.o  \
-  ${OUT}/SAERFFC.o  ${OUT}/SGCF.o    ${OUT}/TBAGG.o   ${OUT}/TBAGG-.o   \
-  ${OUT}/VIEW3D.o   ${OUT}/WFFINTBS.o  \
+  ${OUT}/CCLASS.o   ${OUT}/CPIMA.o   ${OUT}/FSAGG2.o   ${OUT}/GALFACT.o \
+  ${OUT}/IALGFACT.o ${OUT}/IBACHIN.o  ${OUT}/MMLFORM.o ${OUT}/NORMMA.o  \
+  ${OUT}/ODERED.o   ${OUT}/OMSAGG.o   ${OUT}/PERM.o    ${OUT}/PERMGRP.o \
+  ${OUT}/PRIMES.o   ${OUT}/PWFFINTB.o ${OUT}/RDIST.o   ${OUT}/SAE.o     \
+  ${OUT}/SAEFACT.o  ${OUT}/SAERFFC.o  ${OUT}/SGCF.o    ${OUT}/TBAGG.o   \
+  ${OUT}/TBAGG-.o   ${OUT}/VIEW3D.o   ${OUT}/WFFINTBS.o  \
   layer14done
 
 @
@@ -548,27 +551,33 @@ LAYER16=\
   ${OUT}/GOPT.o     ${OUT}/GOPT0.o    ${OUT}/HACKPI.o   ${OUT}/IDEAL.o    \
   ${OUT}/INFORM.o   ${OUT}/INFORM1.o  ${OUT}/IPRNTPK.o  ${OUT}/IR.o       \
   ${OUT}/ISUPS.o    ${OUT}/KERNEL.o   ${OUT}/LIB.o      ${OUT}/LMDICT.o   \
-  ${OUT}/LODOOPS.o  ${OUT}/MATRIX.o   ${OUT}/MKFLCFN.o  ${OUT}/MSET.o     \
-  ${OUT}/M3D.o      ${OUT}/NAGC02.o   ${OUT}/NAGC05.o   ${OUT}/NAGC06.o   \
-  ${OUT}/NAGD01.o   ${OUT}/NAGD02.o   ${OUT}/NAGD03.o   ${OUT}/NAGE01.o   \
-  ${OUT}/NAGE02.o   ${OUT}/NAGE04.o   ${OUT}/NAGF07.o   ${OUT}/NAGS.o     \
-  ${OUT}/NAGSP.o    ${OUT}/NREP.o     ${OUT}/NUMFMT.o   ${OUT}/OC.o       \
-  ${OUT}/OC-.o      ${OUT}/ODEPACK.o  ${OUT}/ODERAT.o   ${OUT}/OMERR.o    \
-  ${OUT}/OMERRK.o   ${OUT}/OPTPACK.o  ${OUT}/OSI.o      ${OUT}/PATTERN.o  \
-  ${OUT}/OVAR.o     ${OUT}/PMKERNEL.o ${OUT}/PMSYM.o    ${OUT}/POLY.o     \
-  ${OUT}/PRIMELT.o  ${OUT}/QALGSET2.o ${OUT}/QEQUAT.o   ${OUT}/RECLOS.o   \
-  ${OUT}/REP1.o     ${OUT}/RESULT.o   ${OUT}/QUATCAT.o  ${OUT}/QUATCAT-.o \
-  ${OUT}/RFFACT.o   ${OUT}/RMATRIX.o  ${OUT}/ROMAN.o    ${OUT}/ROUTINE.o  \
-  ${OUT}/RPOLCAT.o  ${OUT}/RPOLCAT-.o ${OUT}/RULECOLD.o ${OUT}/SAOS.o     \
-  ${OUT}/SEGBIND.o  ${OUT}/SET.o      ${OUT}/SPECOUT.o  ${OUT}/SQMATRIX.o \
-  ${OUT}/SWITCH.o   ${OUT}/SYMS.o     ${OUT}/SYMTAB.o   ${OUT}/SYSSOLP.o  \
-  ${OUT}/UTSCAT.o   ${OUT}/UTSCAT-.o  ${OUT}/VARIABLE.o \
+  ${OUT}/LODO.o     ${OUT}/LODOOPS.o  ${OUT}/MATRIX.o   ${OUT}/MKFLCFN.o  \
+  ${OUT}/MSET.o     ${OUT}/M3D.o      ${OUT}/NAGC02.o   ${OUT}/NAGC05.o   \
+  ${OUT}/NAGC06.o   ${OUT}/NAGD01.o   ${OUT}/NAGD02.o   ${OUT}/NAGD03.o   \
+  ${OUT}/NAGE01.o   ${OUT}/NAGE02.o   ${OUT}/NAGE04.o   ${OUT}/NAGF07.o   \
+  ${OUT}/NAGS.o     ${OUT}/NAGSP.o    ${OUT}/NREP.o     ${OUT}/NUMFMT.o   \
+  ${OUT}/OC.o       ${OUT}/OC-.o      ${OUT}/ODEPACK.o  ${OUT}/ODERAT.o   \
+  ${OUT}/OMERR.o    ${OUT}/OMERRK.o   ${OUT}/OPTPACK.o  ${OUT}/OSI.o      \
+  ${OUT}/PATTERN.o  ${OUT}/OVAR.o     ${OUT}/PMKERNEL.o ${OUT}/PMSYM.o    \
+  ${OUT}/POLY.o     ${OUT}/PRIMELT.o  ${OUT}/QALGSET2.o ${OUT}/QEQUAT.o   \
+  ${OUT}/RECLOS.o   ${OUT}/REP1.o     ${OUT}/RESULT.o   ${OUT}/QUATCAT.o  \
+  ${OUT}/QUATCAT-.o ${OUT}/RFFACT.o   ${OUT}/RMATRIX.o  ${OUT}/ROMAN.o    \
+  ${OUT}/ROUTINE.o  ${OUT}/RPOLCAT.o  ${OUT}/RPOLCAT-.o ${OUT}/RULECOLD.o \
+  ${OUT}/SAOS.o     ${OUT}/SEGBIND.o  ${OUT}/SET.o      ${OUT}/SPECOUT.o  \
+  ${OUT}/SQMATRIX.o ${OUT}/SWITCH.o   ${OUT}/SYMS.o     ${OUT}/SYMTAB.o   \
+  ${OUT}/SYSSOLP.o  ${OUT}/UTSCAT.o   ${OUT}/UTSCAT-.o  \
+  ${OUT}/VARIABLE.o \
   layer16done
 
 @
 \subsection{Layer17}
 Depends on: ACF COMPCAT FFCAT FRNAALG FS OC QUATCAT RPOLCAT UTSCAT\\
 Used by next layer: ACFS EXPRSOL FDIVCAT UFPS ULSCCAT UTSSOL 
+
+The clique1.spad file is used because "MYEXPR" and "MYUP" are 
+mutually dependent. Rather than add one to the bootstrap we let the
+compiler resolve them in one step. This same technique might be useful
+for other cliques in bootstrap. This needs to be investigated.
 <<layer17>>=
 
 LAYER17=\
@@ -577,24 +586,25 @@ LAYER17=\
   ${OUT}/ALGSC.o    ${OUT}/AN.o       ${OUT}/APPRULE.o  ${OUT}/ASP19.o    \
   ${OUT}/ASP20.o    ${OUT}/ASP31.o    ${OUT}/ASP35.o    ${OUT}/ASP41.o    \
   ${OUT}/ASP42.o    ${OUT}/ASP74.o    ${OUT}/ASP77.o    ${OUT}/ASP80.o    \
-  ${OUT}/CINTSLPE.o ${OUT}/COMPFACT.o ${OUT}/COMPLEX.o  ${OUT}/COMPLPAT.o \
-  ${OUT}/CMPLXRT.o  ${OUT}/CPMATCH.o  ${OUT}/CRFP.o     ${OUT}/CTRIGMNP.o \
-  ${OUT}/D01WGTS.o  ${OUT}/D02AGNT.o  ${OUT}/D03EEFA.o  ${OUT}/DBLRESP.o  \
-  ${OUT}/DERHAM.o   ${OUT}/DFSFUN.o   ${OUT}/DRAWCURV.o ${OUT}/D01TRNS.o  \
-  ${OUT}/E04NAFA.o  ${OUT}/EF.o       ${OUT}/EFSTRUC.o  ${OUT}/ELFUTS.o   \
-  ${OUT}/ESTOOLS.o  ${OUT}/EXPEXPAN.o ${OUT}/EXPRODE.o  \
-  ${OUT}/EXPRTUBE.o ${OUT}/EXPR2.o    ${OUT}/FC.o       ${OUT}/FDIVCAT.o  \
-  ${OUT}/FDIVCAT-.o ${OUT}/FDIV2.o    ${OUT}/FFCAT2.o   ${OUT}/FLOATCP.o  \
-  ${OUT}/FORDER.o   ${OUT}/FORTRAN.o  ${OUT}/FRNAAF2.o  ${OUT}/FSRED.o    \
-  ${OUT}/FSUPFACT.o ${OUT}/FSPECF.o   ${OUT}/FS2.o      ${OUT}/FS2UPS.o   \
-  ${OUT}/GAUSSFAC.o ${OUT}/GCNAALG.o  ${OUT}/GENUFACT.o ${OUT}/GENUPS.o   \
-  ${OUT}/GTSET.o    ${OUT}/GPOLSET.o  ${OUT}/IAN.o      ${OUT}/INEP.o     \
-  ${OUT}/INFPROD0.o ${OUT}/INFSP.o    ${OUT}/INPRODFF.o ${OUT}/INPRODPF.o \
-  ${OUT}/INTAF.o    ${OUT}/INTALG.o   ${OUT}/INTEF.o    ${OUT}/INTG0.o    \
-  ${OUT}/INTHERAL.o ${OUT}/INTPAF.o   ${OUT}/INTPM.o    ${OUT}/INTTOOLS.o \
-  ${OUT}/ITRIGMNP.o ${OUT}/JORDAN.o   ${OUT}/KOVACIC.o  ${OUT}/LF.o       \
-  ${OUT}/LIE.o      ${OUT}/LODOF.o    ${OUT}/LSQM.o     ${OUT}/OMEXPR.o   \
-  ${OUT}/MCMPLX.o   ${OUT}/MULTFACT.o ${MID}/clique1.spad \
+  ${OUT}/CINTSLPE.o ${OUT}/COMBF.o    ${OUT}/COMPFACT.o ${OUT}/COMPLEX.o  \
+  ${OUT}/COMPLPAT.o ${OUT}/CMPLXRT.o  ${OUT}/CPMATCH.o  ${OUT}/CRFP.o     \
+  ${OUT}/CTRIGMNP.o ${OUT}/D01WGTS.o  ${OUT}/D02AGNT.o  ${OUT}/D03EEFA.o  \
+  ${OUT}/DBLRESP.o  ${OUT}/D01AGNT.o  ${OUT}/DERHAM.o   ${OUT}/DFSFUN.o   \
+  ${OUT}/DRAWCURV.o ${OUT}/D01TRNS.o  ${OUT}/E04NAFA.o  ${OUT}/EF.o       \
+  ${OUT}/EFSTRUC.o  ${OUT}/ELFUTS.o   ${OUT}/ESTOOLS.o  ${OUT}/EXPEXPAN.o \
+  ${OUT}/EXPRODE.o  ${OUT}/EXPRTUBE.o ${OUT}/EXPR2.o    ${OUT}/FC.o       \
+  ${OUT}/FDIVCAT.o  ${OUT}/FDIVCAT-.o ${OUT}/FDIV2.o    ${OUT}/FFCAT2.o   \
+  ${OUT}/FLOATCP.o  ${OUT}/FORDER.o   ${OUT}/FORTRAN.o  ${OUT}/FRNAAF2.o  \
+  ${OUT}/FSPRMELT.o ${OUT}/FSRED.o    ${OUT}/FSUPFACT.o ${OUT}/FSPECF.o   \
+  ${OUT}/FS2.o      ${OUT}/FS2UPS.o   ${OUT}/GAUSSFAC.o ${OUT}/GCNAALG.o  \
+  ${OUT}/GENUFACT.o ${OUT}/GENUPS.o   ${OUT}/GTSET.o    ${OUT}/GPOLSET.o  \
+  ${OUT}/IAN.o      ${OUT}/INEP.o     ${OUT}/INFPROD0.o ${OUT}/INFSP.o    \
+  ${OUT}/INPRODFF.o ${OUT}/INPRODPF.o ${OUT}/INTAF.o    ${OUT}/INTALG.o   \
+  ${OUT}/INTEF.o    ${OUT}/INTG0.o    ${OUT}/INTHERAL.o ${OUT}/INTPAF.o   \
+  ${OUT}/INTPM.o    ${OUT}/INTTOOLS.o ${OUT}/ITRIGMNP.o ${OUT}/JORDAN.o   \
+  ${OUT}/KOVACIC.o  ${OUT}/LF.o       ${OUT}/LIE.o      ${OUT}/LODOF.o    \
+  ${OUT}/LSQM.o     ${OUT}/OMEXPR.o   ${OUT}/MCMPLX.o   ${OUT}/MULTFACT.o \
+  ${MID}/clique1.spad \
   ${OUT}/NAGF01.o   ${OUT}/NAGF02.o   ${OUT}/NAGF04.o   ${OUT}/NCEP.o     \
   ${OUT}/NLINSOL.o  ${OUT}/NSMP.o     ${OUT}/NUMERIC.o  ${OUT}/OCT.o      \
   ${OUT}/OCTCT2.o   ${OUT}/ODEPAL.o   ${OUT}/ODERTRIC.o ${OUT}/PADE.o     \
@@ -602,8 +612,9 @@ LAYER17=\
   ${OUT}/PMASSFS.o  ${OUT}/PMFS.o     ${OUT}/PMPREDFS.o ${OUT}/PSETPK.o   \
   ${OUT}/QUAT.o     ${OUT}/QUATCT2.o  ${OUT}/RADFF.o    ${OUT}/RDEEF.o    \
   ${OUT}/RDEEFS.o   ${OUT}/RDIV.o     ${OUT}/RSETCAT.o  ${OUT}/RSETCAT-.o \
-  ${OUT}/RULE.o     ${OUT}/RULESET.o  ${OUT}/SIMPAN.o   ${OUT}/SFORT.o    \
-  ${OUT}/SOLVESER.o ${OUT}/SUMFS.o    ${OUT}/SUTS.o     ${OUT}/TOOLSIGN.o \
+  ${OUT}/RSDCMPK.o  ${OUT}/RSETGCD.o  ${OUT}/RULE.o     ${OUT}/RULESET.o  \
+  ${OUT}/SIGNEF.o   ${OUT}/SIMPAN.o   ${OUT}/SFORT.o    ${OUT}/SOLVESER.o \
+  ${OUT}/SOLVETRA.o ${OUT}/SUMFS.o    ${OUT}/SUTS.o     ${OUT}/TOOLSIGN.o \
   ${OUT}/TRIGMNIP.o ${OUT}/TRMANIP.o  ${OUT}/UFPS.o     ${OUT}/ULSCCAT.o  \
   ${OUT}/ULSCCAT-.o ${OUT}/UPXSSING.o ${OUT}/UTSODE.o   ${OUT}/UTSODETL.o \
   ${OUT}/UTSSOL.o   ${OUT}/UTS2.o     ${OUT}/WUTSET.o  \
@@ -611,105 +622,66 @@ LAYER17=\
 
 @
 \subsection{Layer18}
-Depends on: ACFS EXPRSOL FDIVCAT UFPS ULSCCAT UTSSOL 
+Depends on: ACFS EXPRSOL FDIVCAT RSETCAT UFPS ULSCCAT UTSSOL 
+Used in next layer: EXPRSOL SFRTCAT
 <<layer18>>=
 
 LAYER18=\
-  ${OUT}/DEFINTEF.o ${OUT}/DFINTTLS.o ${OUT}/DEFINTRF.o ${OUT}/EFULS.o    \
-  ${OUT}/ESCONT.o   ${OUT}/EXPR.o     ${OUT}/EXPRSOL.o  \
-  ${OUT}/EXPR2UPS.o ${OUT}/FDIV.o     \
-  ${OUT}/FSCINT.o   ${OUT}/FSINT.o    ${OUT}/FS2EXPXP.o ${OUT}/GSERIES.o  \
-  ${OUT}/HELLFDIV.o ${OUT}/INVLAPLA.o ${OUT}/IR2F.o     ${OUT}/IRRF2F.o   \
-  ${OUT}/LAPLACE.o  ${OUT}/LIMITPS.o  ${OUT}/LODEEF.o   ${OUT}/NODE1.o    \
-  ${OUT}/ODECONST.o ${OUT}/ODEINT.o   ${OUT}/REP.o      \
-  ${OUT}/SOLVERAD.o ${OUT}/SULS.o     ${OUT}/SUPXS.o    ${OUT}/UFPS1.o    \
-  ${OUT}/ULS.o      ${OUT}/ULSCONS.o  ${OUT}/UPXS.o     ${OUT}/UPXSCONS.o \
-  ${OUT}/UTS.o \
+  ${OUT}/DEFINTEF.o ${OUT}/DEFINTRF.o ${OUT}/DFINTTLS.o ${OUT}/EFULS.o    \
+  ${OUT}/ESCONT.o   ${OUT}/EXPR.o     ${OUT}/EXPRSOL.o  ${OUT}/EXPR2UPS.o \
+  ${OUT}/FDIV.o     ${OUT}/FSCINT.o   ${OUT}/FSINT.o    ${OUT}/FS2EXPXP.o \
+  ${OUT}/GSERIES.o  ${OUT}/HELLFDIV.o ${OUT}/INVLAPLA.o ${OUT}/IR2F.o     \
+  ${OUT}/IRRF2F.o   ${OUT}/LAPLACE.o  ${OUT}/LIMITPS.o  ${OUT}/LODEEF.o   \
+  ${OUT}/NODE1.o    ${OUT}/NTSCAT.o   ${OUT}/ODECONST.o ${OUT}/ODEEF.o    \
+  ${OUT}/ODEINT.o   ${OUT}/QCMPACK.o  ${OUT}/REGSET.o   ${OUT}/REP.o      \
+  ${OUT}/RGCHAIN.o  ${OUT}/SFRTCAT.o  ${OUT}/SOLVERAD.o ${OUT}/SULS.o     \
+  ${OUT}/SUPXS.o    ${OUT}/UFPS1.o    ${OUT}/ULS.o      ${OUT}/ULSCONS.o  \
+  ${OUT}/UPXS.o     ${OUT}/UPXSCONS.o ${OUT}/UTS.o      ${OUT}/ZDSOLVE.o \
   layer18done
 
 @
 \subsection{Layer19}
-
+Depends on: EXPRSOL SFRTCAT\\
+Next layer depends on: RECOP
 <<layer19>>=
 
 LAYER19=\
+  ${OUT}/RECOP.o    ${OUT}/IRURPK.o   ${OUT}/LAZM3PK.o  ${OUT}/LEXTRIPK.o \
+  ${OUT}/NORMPK.o   ${OUT}/RURPK.o    ${OUT}/SFRGCD.o   ${OUT}/SFQCMPK.o  \
+  ${OUT}/SNTSCAT.o  ${OUT}/SRDCMPK.o  ${OUT}/SREGSET.o  \
   layer19done
 
-
 @
 \subsection{Layer20}
-
+Depends on: RECOP
+Next layer depends on: GUESS
 <<layer20>>=
 
 LAYER20=\
+  ${OUT}/GUESS.o \
   layer20done
     
 @
 \subsection{Layer21}
-
+Depends on: GUESS
+Next layer depends on: GUESSF1
 <<layer21>>=
 
 LAYER21=\
+  ${OUT}/GUESSAN.o  ${OUT}/GUESSINT.o ${OUT}/GUESSF1.o  ${OUT}/GUESSP.o \
+  ${OUT}/GUESSUP.o \
   layer21done
 
 @
 \subsection{Layer22}
-Depends on: EXPRSOL
+Depends on: GUESSF1
 <<layer22>>=
 
 LAYER22=\
-  ${OUT}/ASP29.o    ${OUT}/COMBF.o    ${OUT}/D01AGNT.o  ${OUT}/FSPRMELT.o \
-  ${OUT}/INBFF.o    ${OUT}/LODO.o     ${OUT}/LODO1.o    ${OUT}/LODO2.o    \
-  ${OUT}/NTSCAT.o   ${OUT}/RECOP.o    \
-  ${OUT}/REGSET.o   ${OUT}/RGCHAIN.o  ${OUT}/RSETGCD.o  \
-  ${OUT}/RSDCMPK.o  ${OUT}/SFRTCAT.o  ${OUT}/SIGNEF.o   ${OUT}/SNTSCAT.o  \
-  ${OUT}/SOLVETRA.o ${OUT}/SRDCMPK.o  ${OUT}/SREGSET.o  ${OUT}/STTF.o     \
-  ${OUT}/SUBSPACE.o ${OUT}/ZDSOLVE.o \
+  ${OUT}/GUESSF.o \
   layer22done
 
 @
-\subsection{Final layer spad files}
-These files have not yet been fully analyzed for dependencies but
-have added in alphabetical order in this final layer. This
-ordering is apparently adequate.
-
-These files all depend on layer22.
-\begin{verbatim}
-algcat.spad.pamphlet (CPIMA)
-nregset.spad.pamphlet (NORMPK)
-nsregset.spad.pamphlet (LAZM3PK)
-regset.spad.pamphlet (QCMPACK)
-sregset.spad.pamphlet (SFRGCD SFQCMPK)
-zerodim.spad.pamphlet (LEXTRIPK IRURPK RURPK)
-\end{verbatim}
-
-<<layer23>>=
-
-LAYER23=\
-  ${OUT}/CPIMA.o    ${OUT}/GUESS.o \
-  ${OUT}/IRURPK.o   ${OUT}/LAZM3PK.o  ${OUT}/LEXTRIPK.o \
-  ${OUT}/NORMPK.o   ${OUT}/QCMPACK.o  ${OUT}/RURPK.o    ${OUT}/SFRGCD.o   \
-  ${OUT}/SFQCMPK.o  ${OUT}/INTRVL.o   ${OUT}/ODEEF.o \
-  layer23done
-
-@
-<<layer24>>=
-
-LAYER24=\
-  ${OUT}/GUESSAN.o  ${OUT}/GUESSINT.o  \
-  ${OUT}/GUESSF1.o  ${OUT}/GUESSP.o   ${OUT}/GUESSUP.o \
-  layer24done
-
-@
-\subsection{User Layer for newly added algebra}
-Rather than classify newly created algebra into the existing type lattice
-we add it here.
-<<USERLAYER>>=
-
-USERLAYER=\
-  ${OUT}/GUESSF.o \
-  ${OUT}/RINTERP.o
-@
 \subsection{Order}
 The final order of the layers is determined here.
 <<order>>=
@@ -719,7 +691,7 @@ ORDER=\
   ${LAYER4}   ${LAYER5}  ${LAYER6}  ${LAYER7}  ${LAYER8}  ${LAYER9}  \
   ${LAYER10}  ${LAYER11} ${LAYER12} ${LAYER13} ${LAYER14} ${LAYER15} \
   ${LAYER16}  ${LAYER17} ${LAYER18} ${LAYER19} ${LAYER20} ${LAYER21} \
-  ${LAYER22}  ${LAYER23} ${LAYER24} ${USERLAYER} ${LAYER0COPY}
+  ${LAYER22}  ${LAYER0COPY}
 
 @
 \section{Cliques}
@@ -2964,9 +2936,6 @@ ${HELP}/ZeroDimensionalSolvePackage.help: ${IN}/zerodim.spad.pamphlet
 <<layer20>>
 <<layer21>>
 <<layer22>>
-<<layer23>>
-<<layer24>>
-<<USERLAYER>>
 <<order>>
 
 all: src ${OUT}/libdb.text ${DOCFILES} ${SPADBIN}/index.html \
diff --git a/src/axiom-website/patches.html b/src/axiom-website/patches.html
index 1c48c17..b31dabe 100644
--- a/src/axiom-website/patches.html
+++ b/src/axiom-website/patches.html
@@ -861,6 +861,8 @@ algebra/Makefile move layers 15, 16, 17, 18, 19 <br/>
 algebra/Makefile rearrange build order <br/>
 <a href="patches/20081226.02.tpd.patch">20081226.02.tpd.patch</a>
 algebra/Makefile rearrange build order <br/>
+<a href="patches/20081227.01.tpd.patch">20081227.01.tpd.patch</a>
+algebra/Makefile complete build order change <br/>
 
  </body>
 </html>
